#include "div.h"
#include <stdio.h>

extern int Index(int **tab,int i,int j);

int Front_Covering(int size,int *front1,int *front2,int PTS,int **point,
                   int *nb_mat,int *connect,int *connect2,int *voisins,
                   int *c_order,int *link,int *nc1,int *nc2,int p[3][Max_trn],
                   int *ptx,int *pty)
{
  int maincon, ncn,mainlink;
  int i,j,k,m;
  int n1,n2,c1,c2,f1,f2,corder1,corder2;
  int total;

  total=0;

  for(i=size-1;i>0&&front1[i]!=front2[i];i--)
    {

      /* For each mono-color couple of points, finding # neighbours in the */
      /* same strong component.                                            */

      n1=front1[i];    n2=front2[i];
      c1=front1[i+1];  c2=front2[i+1];

      ncn=nc1[connect[n1]];
      if(voisins[n1]==1) corder1=c_order[n1]+1;
	else {
	       f1=front1[i-1];
	       for(j=0;point[n1][j]!=f1;j++);
	       m=nb_mat[n1];
	       maincon=connect[n1];
	       while(connect[point[n1][j]]!=maincon) j=(j+1)%m;
	       corder1=c_order[point[n1][j]]+2;
	     }
      corder1=corder1%ncn;
      if(voisins[n2]==1) corder2=c_order[n2]-1;
	else {
	       f2=front1[i-1];
	       for(j=0;point[n1][j]!=f2;j++);
	       m=nb_mat[n1];
	       maincon=connect[n1];
	       while(connect[point[n1][j]]!=maincon) j=(j+1)%m;
	       corder2=c_order[point[n1][j]];
	     }
      corder2=(corder2+ncn)%ncn;
      total+=(corder2-corder1+ncn+1)%ncn;

      /****************** Dealing with inheritance ... **********************/

      if(corder2<corder1) corder2+=ncn;
      if((corder2-corder1+1)%ncn!=0)
	for(j=1;j<=PTS;j++)
	   if(connect[j]==j)
	     if(connect[link[j]]==connect[n1]&&j!=connect[c1])
	       {
		 mainlink=c_order[link[j]];
		 if((mainlink>=corder1&&mainlink<=corder2)
		    ||(mainlink<corder1&&mainlink+ncn<=corder2))
		   {
		     total+=nc1[j];
		     for(k=1;k<=PTS;k++)
		       if(connect2[k]==k)
			 if(connect[link[k]]==j)
			   {
			     total+=nc2[k];
			   }
		   }
	       }
    }
  return total;
}

/******************* Finding a minimal way on the mesh ***********************/

void Find_min_front(triangulation *trngl,tree_structure *tree,int i,int j,
                    int *front,int *mark_p,int size,int adv,int **lien)
{ 
  int p1,p2;
  int k,l,c;
  int through,kmod;

  /*** Initializing the through variables : they are used   ***/
  /*** check whether one front is yours or not, meaning     ***/
  /*** you can go through or not.                           ***/

  p1=front[size]; p2=front[size-1];
  through=0;
  if(mark_p[front[size-1]]==2)
    {
      k=front[size-1];
      for(l=0;tree->mode[l]!=1||tree->value[l]!=k;l++);
      if(tree->ref[j]==i)
        while(l!=0&&l!=j) l=tree->ref[l];
      else
        while(l!=0&&l!=i) l=tree->ref[l];
      if((tree->ref[j]!=i||l!=j)
         &&(tree->ref[i]!=j||l!=0))
         through=1; 
    }

  /*** Going down when one knows the top ... ***/

  for(c=size-2;c>0;c--)
    {
      /*** Computation for front ***/
      k=front[c+1];
      kmod=trngl->nb_mat[k];
      l=Index(trngl->point,k,front[c+2]);
      if(!through)
        {
    	  l=(l+adv+kmod)%kmod;
  	  while(lien[k][l]!=11&&lien[k][l]!=1)
  	    l=(l+adv+kmod)%kmod;
  	  while(lien[k][l]==1)
  	    l=(l+adv+kmod)%kmod;
  	  if(lien[k][l]!=11)
  	    l=(l-adv+kmod)%kmod;
        }
      else 
        while(lien[k][l]!=1&&lien[k][l]!=11) 
  	l=(l-adv+kmod)%kmod;
      front[c]=trngl->point[k][l];
      p1=front[c]; p2=front[c+1];
      /*** Refreshing through ***/
      if(mark_p[trngl->point[k][l]]==2)
  	{
  	  k=trngl->point[k][l];
  	  for(l=0;tree->mode[l]!=1||tree->value[l]!=k;l++);
  	  if(tree->ref[j]==i)
  	    while(l!=0&&l!=j) l=tree->ref[l];
  	  else
  	    while(l!=0&&l!=i) l=tree->ref[l];
  	  if((tree->ref[j]==i&&l==j)
  	     ||(tree->ref[i]==j&&l==0))
  	     through=0;
  	  else through=1;
  	}
    }
}

/***************************** Front Comparator ******************************/

int Bound(int *nb_mat,int **point,int *front1,int *front2,int size)
{
  int b,pivot,mod,ref,dir;

  dir=1;
  b=size;
  while(b>1&&front1[b]==front2[b]) b--;
  while(b>1&&front1[b]!=front2[b]) b--;
  /*printf("Bound(%i) %i ",size,b);*/
  if(b<size-1&&b>1)
    {
      /***** initializing pivot, mod, ref, dir ... *****/
      pivot=front1[b];
      mod=nb_mat[pivot];
      ref=Index(point,front1[b],front1[b-1])-mod;
      if((Index(point,front1[b],front1[b+1])-ref)%mod
        <(Index(point,front1[b],front2[b+1])-ref)%mod)
        dir=-1;
      else dir=1;
      while(b>1&&front1[b]==front2[b]) b--;
      pivot=front1[b+1];
      mod=nb_mat[pivot];
      ref=Index(point,front1[b+1],front1[b+2])-mod;
      /***** main loop *****/
      while(b>1&&front1[b]!=front2[b]&&
        ((Index(point,pivot,front1[b])-ref)%mod)*dir
             <((Index(point,pivot,front2[b])-ref)%mod)*dir)
        {
          while(b>1&&front1[b]!=front2[b]) b--;
          pivot=front1[b];
          mod=nb_mat[pivot];
          ref=Index(point,front1[b],front1[b-1])-mod;
          if((Index(point,front1[b],front1[b+1])-ref)%mod
            <(Index(point,front1[b],front2[b+1])-ref)%mod)
            dir=-1;
          else dir=1;
          while(b>1&&front1[b]==front2[b]) b--;
          pivot=front1[b+1];
          mod=nb_mat[pivot];
          ref=Index(point,front1[b+1],front1[b+2])-mod;
        }
      /*printf("-> %i ",b);*/
      /***** replacing in case it is necessary *****/
      if(front1[b+1]==front2[b+1])
        if(((Index(point,front1[b+1],front1[b])-ref)%mod)*dir
             >((Index(point,front1[b+1],front2[b])-ref)%mod)*dir)
          b++;
      /*printf("-> %i ",b);*/
    }
  if(front1[b]==front2[b]&&dir==1)
    while(front1[b+1]==front2[b+1]) b++;
  /*printf("-> %i\n",b);*/
  return(b);
}

int Front_is_inferior(int *front1,int b1,int *front2,int b2,int *front,
                      int size,int *c_order,int *nc1,int *connect)
{
  int i,mod,abs,strict=0,inf=0;

  for(i=size;i>=b1&&i>=b2;i--)
    if(front1[i]!=front2[i])
      {
        mod=nc1[connect[front[i]]];
        abs=c_order[front[i]]-mod;
        if((c_order[front1[i]]-abs)%mod!=0&&(c_order[front2[i]]-abs)%mod!=0)
          {
          inf=inf||((c_order[front1[i]]-abs)%mod<(c_order[front2[i]]-abs)%mod);
          strict=1;
	  }
      }
  if (!strict) inf=(b1<b2);
  return(inf);
}

/*************************** Main tree builder *******************************/

void Domain_Divider(triangulation trngl,tree_structure tree,int **lien,
                    int *color,int *trn_color,int nocolor,int *voisins,
                    int *link,int *nc1,int *nc2,int *connect,int *connect2,
                    int *c_order,int *mark_p,Node **Join,Domain *dom,
                    int *total_domain,int *extract_node)
{
  int *nb_mat=trngl.nb_mat;
  int **point=trngl.point, **triangle=trngl.triangle; 
  int (*p)[Max_trn]=trngl.p;

  int i,j,k,l,c,c2;
  int front1[Max_pile],front2[Max_pile],sons[Max_pile],size;
  int max1,max2,chef1,chef2;
  Node *I_node;
  int bound,cl[Max_pile],cl_inv[Max_pile];
  int tree_node[Max_pile];
  int future_pile[Max_pile], future_past[Max_pile];
  int work, mode;
  int next2,nextnode2,bound2,*f1,*f2;
  int horizon[Max_pile];
  int complex2, total_node;
  FILE *j_file;

  /************************ Choosing a central line **************************/

  /*** This part of the compution is quite long,  hard to understand,      ***/
  /*** and perhabs useless. It is given as an example of fast statistics   ***/
  /*** provided by deepness analysis. An other interesting point is the    ***/
  /*** use of minimal front to introduce choice.                           ***/

  for(i=0;i<tree.total;i++)
    {
      tree.owner[i]=-1;
      sons[i]=0;
      sons[tree.ref[i]]++;
    }

  sons[0]-=2;

  for(i=0;i<tree.total;i++)
    if(sons[i]>1)
      {
        /******************** Initializing I_node structure ******************/

        I_node=(Node *)malloc(sizeof(Node));
        Join[i]=I_node;
        I_node->complex=0;
        I_node->next=(int *)malloc(sizeof(int)*(sons[i]+1));
        I_node->nextnode=(int *)malloc(sizeof(int)*(sons[i]+1));
        I_node->domain=(int *)malloc(sizeof(int)*((sons[i]+1))*2);
        I_node->bound=(int *)malloc(sizeof(int)*(sons[i]+1));
        I_node->front1=(int **)malloc(sizeof(int *)*(sons[i]+1));
        I_node->front2=(int **)malloc(sizeof(int *)*(sons[i]+1));

        /*********************************************************************/
	chef1=tree.total;
	chef2=tree.total;
	max1=-1;
	max2=-1;
	for(j=0;j<tree.total;j++)
	  {
	    if((tree.ref[j]==i||tree.ref[i]==j)&&i!=j)
	      {
		if(tree.mode[i]==1)
		  if(tree.mode[j]==1)
		    {
		      /*** point - point separating ***/
		      k=tree.value[i];
		      size=color[k];
		      front1[size]=k;
		      front2[size]=k;
		      for(l=0;point[k][l]!=tree.value[j];l++);
		      if(lien[k][l]==4||lien[k][l]==2||lien[k][l]==10)
			{
			  for(c=l;color[point[k][c]]!=size-1;
			    c=(c-1+nb_mat[k])%nb_mat[k]);
			  front1[size-1]=point[k][c];
			  for(c=l;color[point[k][c]]!=size-1;
			    c=(c+1)%nb_mat[k]);
			  front2[size-1]=point[k][c];
			}
		      else
			{
			  front1[size-1]=tree.value[j];
			  front2[size-1]=tree.value[j];
			}
		    }
		  else
		    {
		      /*** point - triangle separating ***/

			  k=tree.value[i];
			  size=color[k];
			  front1[size]=k;
			  front2[size]=k;
			  for(l=0;triangle[k][l]!=tree.value[j];l++);
			  for(c=l;color[point[k][c]]!=size-1;
			    c=(c-1+nb_mat[k])%nb_mat[k]);
			  front1[size-1]=point[k][c];
			  for(c=(l+1)%nb_mat[k];color[point[k][c]]!=size-1;
			    c=(c+1)%nb_mat[k]);
			  front2[size-1]=point[k][c];
		    }
		  else
		    {
		      if(tree.mode[j]==1)
			{
			  /*** triangle - point separating ***/
			  k=tree.value[j];
			  size=color[k];
			  front1[size]=k;
			  front2[size]=k;
			  for(l=0;triangle[k][l]!=tree.value[i];l++);
			  for(c=l;color[point[k][c]]!=size-1;
			    c=(c-1+nb_mat[k])%nb_mat[k]);
			  while(lien[k][c]==1)
			    c=(c-1+nb_mat[k])%nb_mat[k];
			  if(lien[k][c]!=11)
			    c=(c+1)%nb_mat[k];
			  front2[size-1]=point[k][c];

			  for(c=(l+1)%nb_mat[k];color[point[k][c]]!=size-1;
			    c=(c+1)%nb_mat[k]);
			  while(lien[k][c]==1)
			    c=(c+1)%nb_mat[k];
			  if(lien[k][c]!=11)
			    c=(c-1+nb_mat[k])%nb_mat[k];
			  front1[size-1]=point[k][c];

			}
		      else
			{
			  /*** triangle - triangle separating ***/
			  for(l=0;l<3;l++)
			    {
			      k=p[(l+2)%3][tree.value[j]];
			      for(c=0;point[k][c]!=p[l][tree.value[j]];c++);
			      if(triangle[k][(c-1+nb_mat[k])%nb_mat[k]]
				 ==tree.value[i])
				{
				  k=p[l][tree.value[j]];
				  size=color[k];
				  front1[size]=k;
				  if(mark_p[k]==2)
				    {
				      for(c=0;
					tree.mode[c]!=1||tree.value[c]!=k;
					c++); 
				      if(tree.ref[j]==i)
					while(c!=j&&c!=0) c=tree.ref[c];
				      else
					while(c!=i&&c!=0) c=tree.ref[c];
				    }
				  if(mark_p[k]==2&&
				     (c==j&&tree.ref[j]==i||
				     c==0&&tree.ref[i]==j))
				    {
				      for(c2=0;
					triangle[k][c2]!=tree.value[i];c2++);
				      for(c=(c2+1)%nb_mat[k];
					color[point[k][c]]!=size-1;
					c=(c+1)%nb_mat[k]);
				      while(lien[k][c]==1)
					c=(c+1)%nb_mat[k];
				      if(lien[k][c]!=11)
					c=(c-1+nb_mat[k])%nb_mat[k];
				      front1[size-1]=point[k][c];
				    }
				  else
				    {
				      for(c=0;
					point[k][c]!=p[(l+1)%3][tree.value[j]];
					c++);
				      while(color[point[k][c]]!=size-1)
					c=(c-1+nb_mat[k])%nb_mat[k];
				      front1[size-1]=point[k][c];
				    }


				  k=p[(l+2)%3][tree.value[j]];
				  front2[size]=k;
				  if(mark_p[k]==2)
				    {
				      for(c=0;
					tree.mode[c]!=1||tree.value[c]!=k;
					c++);
				      if(tree.ref[j]==i)
					while(c!=j&&c!=0) c=tree.ref[c];
				      else
					while(c!=i&&c!=0) c=tree.ref[c];
				    }
				  if(mark_p[k]==2&&
				     (c==j&&tree.ref[j]==i||
				     c==0&&tree.ref[i]==j))
				    {
				      for(c2=0;
					triangle[k][c2]!=tree.value[i];c2++);
				      for(c=c2;color[point[k][c]]!=size-1;
					c=(c-1+nb_mat[k])%nb_mat[k]);
				      while(lien[k][c]==1)
					c=(c-1+nb_mat[k])%nb_mat[k];
				      if(lien[k][c]!=11)
					c=(c+1)%nb_mat[k];
				      front2[size-1]=point[k][c];
				    }
				  else
				    {
				      for(c=0;
					point[k][c]!=p[(l+1)%3][tree.value[j]];
					c++);
				      while(color[point[k][c]]!=size-1)
					c=(c+1)%nb_mat[k];
				      front2[size-1]=point[k][c];
				    }
				}
			    }
			}
		   }

                Find_min_front(&trngl,&tree,i,j,front1,mark_p,size,1,lien);
                Find_min_front(&trngl,&tree,i,j,front2,mark_p,size,-1,lien);

                /** storing a trace of the fronts for the "node" structure ***/

                if(I_node->complex>0&&I_node->size!=size)
                  printf("Error on size detected [%i & %i]\n",
                         I_node->size,size);
                I_node->size=size;
                I_node->front1[I_node->complex]
                   =(int *)malloc((size+1)*sizeof(int));
                I_node->front2[I_node->complex]



                   =(int *)malloc((size+1)*sizeof(int));
                for(k=1;k<=size;k++)
                  {
                    I_node->front1[I_node->complex][k]=front1[k];
                    I_node->front2[I_node->complex][k]=front2[k];
                  }
                I_node->next[I_node->complex++]=j;

#ifdef OLDSTORE
                printf("COUCOU :\n");
		/*** preparing fronts and giving them to Front_Covering ***/

		while(front1[size-1]==front2[size-1]&&size>2) size--;
		c=Front_Covering(size,front2,front1,PTS,point,nb_mat,
		    connect,connect2,voisins,c_order,link,nc1,nc2,p,ptx,pty);

		/*** storing current fronts ***/

		if(c>max2&&chef2!=-1)
		  {
		    tree.owner[chef2]=i;
		    size_inf[chef2]=size_cour[chef2];
		    front_inf1[chef2]=front_cour1[chef2];
		    front_inf2[chef2]=front_cour2[chef2];
		  }

		/*** finding new chefs ***/

		if(c>max1) { chef2=chef1; max2=max1; chef1=j; max1=c; }
		     else  if(c>max2) { chef2=j; max2=c; }
			       else   tree.owner[j]=i;

		/*** refreshing storage when necessary ***/

		if(tree.owner[j]!=i)
		  { 
		    size_cour[j]=size;
		    front_cour1[j]=(int *)malloc((size+2)*sizeof(int));
		    front_cour2[j]=(int *)malloc((size+2)*sizeof(int));
		    for(k=1;k<=size;k++)
		      {
			front_cour1[j][k]=front1[k];
			front_cour2[j][k]=front2[k];
		      }
		  }
		else
		  { 
		    size_inf[j]=size;
		    front_inf1[j]=(int *)malloc((size+2)*sizeof(int));
		    front_inf2[j]=(int *)malloc((size+2)*sizeof(int));
		    for(k=1;k<=size;k++)
		      {
			front_inf1[j][k]=front1[k];
			front_inf2[j][k]=front2[k];
		      }
		  }
#endif
	      }
	  }
      }

  /********************* Link the nodes one to another ***********************/

  total_node=0;
  for(i=0;i<tree.total;i++)
    if(sons[i]>1)
      {
        extract_node[i]=total_node++;
        tree_node[i]=i;
        for(j=0;j<Join[i]->complex;j++) Join[i]->nextnode[j]=-1;
      }
    else
      {
        tree_node[i]=-1;
        extract_node[i]=-1;
      }

  for(i=0;i<tree.total;i++)
    if(sons[i]>1)
      {
        for(j=tree.ref[i],k=i;tree_node[j]==-1;j=tree.ref[j])
          {
            tree_node[j]=i;
            k=j;
          }
        if(tree_node[j]!=i)
          {
            for(l=0;Join[i]->next[l]!=tree.ref[i];l++);
            Join[i]->nextnode[l]=tree_node[j];
            if(sons[j]>1) /* the link is made downstairs */
              {
                for(l=0;Join[j]->next[l]!=k;l++);
                Join[j]->nextnode[l]=i;
              }
            else          /* the two nodes are encountering e.o. on the top */
              {
                j=tree_node[0];
                for(l=0;Join[j]->next[l]!=tree.ref[j];l++);
                Join[j]->nextnode[l]=i;
              }
          }
      }

  /******************* Reformating fronts for cohesion ***********************/

  for(k=0;k<tree.total&&sons[k]<2;k++);
  if(k<tree.total)
    {
      work=0;
      for(i=0;i<Join[k]->complex;i++) 
        if(Join[k]->nextnode[i]!=-1)
          {
            future_pile[work]=Join[k]->nextnode[i];
            future_past[work++]=k;
          }
      while(work-->0)
        {
          i=future_pile[work];
          k=future_past[work];
          for(j=0;j<Join[i]->complex;j++)
            if(Join[i]->nextnode[j]!=k&&Join[i]->nextnode[j]!=-1)
              {
                future_pile[work]=Join[i]->nextnode[j];
                future_past[work++]=i;
              }
          for(j=0;Join[i]->nextnode[j]!=k;j++);
          for(l=0;Join[k]->nextnode[l]!=i;l++);
          size=Join[k]->size;
          if(size>Join[i]->size) size=Join[i]->size;
          f1=Join[k]->front1[l];
          f2=Join[i]->front2[j];
          mode=0;
          for(c=size-1;c>=1;c--)
            {
              mode=(f1[c+1]==f2[c+1]);
              if(mode) f2[c]=f1[c];
            }
          f1=Join[k]->front2[l];
          f2=Join[i]->front1[j];
          mode=0;
          for(c=size-1;c>=1;c--)
            {
              mode=(f1[c+1]==f2[c+1]);
              if(mode) f2[c]=f1[c];
            }
        }
    }

  /************************* Ordering nodes *********************************/

  for(i=0;i<tree.total;i++)
    if(sons[i]>1)
      {
        I_node=Join[i];
        for(j=0;j<I_node->complex;j++)
         I_node->bound[j]=
          Bound(nb_mat,point,I_node->front1[j],I_node->front2[j],I_node->size);
        bound=I_node->bound[0];
        for(j=1;j<I_node->complex;j++)
          if(I_node->bound[j]<bound) bound=I_node->bound[j];
        for(chef1=0;I_node->bound[chef1]!=bound;chef1++);
        cl[0]=chef1;

        for(j=0;j<chef1;j++)
          {
            k=j;
            l=cl[k];
            while(Front_is_inferior(
              I_node->front1[j],I_node->bound[j],
              I_node->front1[l],I_node->bound[l],
              I_node->front1[chef1],I_node->size,
              c_order,nc1,connect))
                l=cl[--k];
            k++;
            for(l=j-1;l>=k;l--) cl[l+1]=cl[l];
            cl[k]=j;
          }
        for(j=chef1+1;j<I_node->complex;j++)
          {
            k=j-1;
            l=cl[k];
            while(Front_is_inferior(
              I_node->front1[j],I_node->bound[j],
              I_node->front1[l],I_node->bound[l],
              I_node->front1[chef1],I_node->size,
              c_order,nc1,connect))
                l=cl[--k];
            k++;
            for(l=j-1;l>=k;l--) cl[l+1]=cl[l];
            cl[k]=j;
          }

        for(j=0;j<I_node->complex;j++) cl_inv[cl[j]]=j;
        for(j=0;j<I_node->complex;j++)
          if(cl[j]!=j)
            {
              k=cl[j];
              cl[cl_inv[j]]=k;

              next2     = I_node->next[k];
              nextnode2 = I_node->nextnode[k];
              bound2    = I_node->bound[k];
              f1        = I_node->front1[k];
              f2        = I_node->front2[k];

              I_node->next[k]     = I_node->next[j];
              I_node->nextnode[k] = I_node->nextnode[j];
              I_node->bound[k]    = I_node->bound[j];
              I_node->front1[k]   = I_node->front1[j];
              I_node->front2[k]   = I_node->front2[j];

              I_node->next[j]     = next2;
              I_node->nextnode[j] = nextnode2;
              I_node->bound[j]    = bound2;
              I_node->front1[j]   = f1;
              I_node->front2[j]   = f2;
            }
      }

  /************ Forming an adequate structure for separate analysis **********/

  for(i=0;i<tree.total;i++)
    if(sons[i]>1)
      {
        I_node=Join[i];
        size=I_node->size;
        for(j=1;j<=size;j++) horizon[j]=I_node->front1[0][j];
        for(j=I_node->bound[0]-1;j>0;j--)
          I_node->front2[0][j]=I_node->front1[0][j];
        for(j=1;j<I_node->complex;j++)
          {
            if(I_node->front1[j][I_node->bound[j]]
               == I_node->front2[j][I_node->bound[j]])
            {
              for(k=I_node->bound[j];I_node->front1[j][k]!=horizon[k]&&k>0;k--)
                I_node->front2[j][k]=I_node->front1[j][k];
              for(k=k;k>0;k--)
                {
                  I_node->front1[j][k]=horizon[k];
                  I_node->front2[j][k]=horizon[k];
                }
            }
            for(k=1;k<=size;k++) horizon[k]=I_node->front1[j][k];
          }
      }

  /**************************** Domain extraction ***************************/

  j_file=fopen(NODE_NAME,"w");

  fwrite(&total_node,sizeof(int),1,j_file);
  printf("TOTALNODE : %i\n",total_node);

  *total_domain=0;
  for(i=0;i<tree.total;i++)
    if(sons[i]>1)
      {
        I_node=Join[i];
        complex2=0;
        for(j=0;j<I_node->complex;j++) 
          {
            if(I_node->nextnode[j]>i)
              {
                future_pile[complex2++]=*total_domain;
                I_node->domain[j]=*total_domain;
                dom[*total_domain].size_a=I_node->size;
                dom[*total_domain].node_a=i;
                dom[*total_domain].front1_a=I_node->front1[j];
                dom[*total_domain].front2_a=I_node->front2[j];
                dom[*total_domain].chef_a=i;
                dom[*total_domain].newchef_a=I_node->next[j];

                k=I_node->nextnode[j];
                dom[*total_domain].size_b=Join[k]->size;
                dom[*total_domain].node_b=k;
                for(l=0;Join[k]->nextnode[l]!=i;l++);
                dom[*total_domain].front1_b=Join[k]->front1[l];
                dom[*total_domain].front2_b=Join[k]->front2[l];
                dom[*total_domain].chef_b=k;
                dom[(*total_domain)++].newchef_b=Join[k]->next[l];
              }
            else if(I_node->nextnode[j]==-1)
              {
                future_pile[complex2++]=*total_domain;
                dom[*total_domain].size_b=I_node->size;
                dom[*total_domain].node_b=i;
                dom[*total_domain].front1_b=I_node->front1[j];
                dom[*total_domain].front2_b=I_node->front2[j];
                dom[*total_domain].chef_b=i;
                dom[*total_domain].newchef_b=I_node->next[j];

                dom[*total_domain].node_a=-1;
                chef2=i;
                k=I_node->next[j];
                do
                 {
                   chef1=chef2;
                   chef2=k;
                   for(k=0;((tree.ref[k]!=chef2&&tree.ref[chef2]!=k)
                     ||k==chef1||k==chef2)&&k<tree.total;k++);
                 } 
                while(k!=tree.total);
                dom[*total_domain].chef_a=chef2;
                dom[(*total_domain)++].newchef_a=chef1;
              }
            else {
                   k=I_node->nextnode[j];
                   for(l=0;Join[k]->nextnode[l]!=i;l++);
                   future_pile[complex2++]=Join[k]->domain[l];
                 }

            k=(j+1)%I_node->complex;
            c=1;
            for(l=1;l<=I_node->size;l++)
              c=c&&(I_node->front2[k][l]==I_node->front1[j][l]);

            if(!c)
              {
                future_pile[complex2++]=*total_domain;
                dom[*total_domain].size_a=I_node->size;
                dom[*total_domain].node_a=i;
                dom[*total_domain].front1_a=I_node->front1[j];
                dom[*total_domain].front2_a=I_node->front1[j];
                dom[*total_domain].chef_a=i;
                dom[*total_domain].newchef_a=tree.total;

                dom[*total_domain].size_b=I_node->size;
                dom[*total_domain].node_b=i;
                dom[*total_domain].front1_b=I_node->front2[k];
                dom[*total_domain].front2_b=I_node->front1[j];
                dom[*total_domain].chef_b=i;
                dom[(*total_domain)++].newchef_b=tree.total;
              }
          }
        fwrite(&complex2,sizeof(int),1,j_file);
        fwrite(&future_pile,sizeof(int),complex2,j_file);
      }
  fclose(j_file);
}
