#include <sys/types.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include "div.h"

extern void Load_Mesh(triangulation *trngl);
extern void Set_Colors(triangulation trngl,int *nocolor,int *color,
                       int *trn_color);
extern void Pre_Analyse(triangulation *trngl,int **lien,int *color,
                        int *trn_color);
extern void Strong_connexity(triangulation trngl,int **lien,int *color,
                      int *trn_color,int *connect,int *voisins,
			     int *frere,int *soeur,int *nc1);
extern void Super_Srong_Connexity(triangulation trngl,int nocolor,int *voisins,
				  int *frere,int *trn_color,int *con_trn0);
extern void Strong_Connexity_Numbering(triangulation trngl,int **lien,
     int *frere,int *soeur,int *connect,int *nc1,int *con_trn0,
     int *voisins,int *c_order,int *connect0,int *enter_node,
     int *exit_node,int *trn_color);
extern void Weak_Connexity(triangulation trngl,int **lien,int *connect,
                           int *color,int *connect2,int *link,
                           int *sons,int *nc2);
extern void Tree_Builder(triangulation trngl,tree_structure *tree,int *mark_p,
                  int **lien,int *color,int *trn_color,int nocolor,
			 int *voisins,int *link,int *connect);
extern void Domain_Divider(triangulation trngl,tree_structure tree,int **lien,
                    int *color,int *trn_color,int nocolor,int *voisins,
                    int *link,int *nc1,int *nc2,int *connect,int *connect2,
                    int *c_order,int *mark_p,Node **Join,Domain *dom,
			   int *total_domain,int *extract_node);
extern void Domain_reorderer(triangulation *trngl,tree_structure *tree,
			     Domain *dom,int total,int *color,int *trn_color,
			     int *mark_t,int **lien,int *extract_node);

int Index(int **tab,int i,int j);

/* PAS (6/4/96) */
#ifdef SOLARIS_COMPILE_ONLY
int ftime(struct timeb *tp) { tp = NULL; return (0); }
#endif

void main(void)
{
  struct timeb tp1,tp2;


  /************************ general graph definitions ***********************/
  triangulation trngl;
  tree_structure tree;

  int color[Max_pts],trn_color[Max_trn];
  int nocolor;
  /************************ general connexity variables *********************/
  int connect0[Max_pts], connect[Max_pts], connect2[Max_pts];
  int con_trn0[Max_trn], voisins[Max_pts];
  int nc1[Max_pts],nc2[Max_pts],sons[Max_pts],link[Max_pts],c_order[Max_pts];
  int frere[Max_pts],soeur[Max_pts];
  int enter_node[Max_trn],exit_node[Max_trn];
  int *lien[Max_pts];
  int mark_p[Max_pts];
  int mark_t[Max_trn];
  Node *Join[Max_pile];
  Domain domain[Max_pile];
  int total_domain;
  int extract_node[Max_tree];

  ftime(&tp1);

  ftime(&tp2);
  printf("Load_Mesh                  %i.%03i\n",tp2.time,tp2.millitm);
  Load_Mesh(&trngl);

  ftime(&tp2);
  printf("Set_Colors                 %i.%03i\n",tp2.time,tp2.millitm);
  Set_Colors(trngl,&nocolor,color,trn_color);

  ftime(&tp2);
  printf("Pre_Analyse                %i.%03i\n",tp2.time,tp2.millitm);
  Pre_Analyse(&trngl,lien,color,trn_color);

  ftime(&tp2);
  printf("Strong_connexity           %i.%03i\n",tp2.time,tp2.millitm);
  Strong_connexity(trngl,lien,color,trn_color,
    connect,voisins,frere,soeur,nc1);

  ftime(&tp2);
  printf("Super_Strong_connexity     %i.%03i\n",tp2.time,tp2.millitm);
  Super_Srong_Connexity(trngl,nocolor,voisins,frere,
    trn_color,con_trn0);

  ftime(&tp2);
  printf("Strong_Connexity_Numbering %i.%03i\n",tp2.time,tp2.millitm);
  Strong_Connexity_Numbering(trngl,lien,frere,soeur,connect,nc1,con_trn0,
    voisins,c_order,connect0,enter_node,exit_node,trn_color);

  ftime(&tp2);
  printf("Weak_Connexity             %i.%03i\n",tp2.time,tp2.millitm);
  Weak_Connexity(trngl,lien,connect,color,connect2,link,sons,nc2);

  ftime(&tp2);
  printf("Tree_Builder               %i.%03i\n",tp2.time,tp2.millitm);
  Tree_Builder(trngl,&tree,mark_p,
    lien,color,trn_color,nocolor,voisins,link,connect);

  ftime(&tp2);
  printf("Domain_Divider             %i.%03i\n",tp2.time,tp2.millitm);
  Domain_Divider(trngl,tree,lien,color,trn_color,nocolor,
    voisins,link,nc1,nc2,connect,connect2,c_order,mark_p,
    Join, domain, &total_domain,extract_node);

  ftime(&tp2);
  printf("Domain_Reorderer           %i.%03i\n",tp2.time,tp2.millitm);
  Domain_reorderer(&trngl,&tree,domain,total_domain,
    color,trn_color,mark_t,lien,extract_node);


  ftime(&tp2);
  printf("Times %i.%03i %i.%03i\n",
    tp1.time,tp1.millitm,tp2.time,tp2.millitm);

}

int Index(int **tab,int i,int j)
{
  int k;

  for(k=0;tab[i][k]!=j;k++);
  return(k);
}
