#include "div.h"
#include <stdio.h>

extern int Index(int **tab,int i,int j);

void Go_Front(trngl,front,front_goal,side,size,mark_t,
               lien,trn_color,number,flag)
triangulation *trngl;
int *front, *front_goal, side, size;
int *mark_t, **lien, *trn_color, *number, *flag;
{
  int **point=trngl->point,**triangle=trngl->triangle,(*p)[Max_trn]=trngl->p;

  int c1,c2,pt;
  int k, lnk, not_mine;

  for(k=1,not_mine=1;k<size&&not_mine==1;k++)
    if(front[k]!=front_goal[k])
    {
      pt=front[k];
      if(side==1) c1=triangle[pt][Index(point,pt,front[k+1])];
        else      c1=triangle[front[k+1]][Index(point,front[k+1],pt)];
      if(side==1) lnk=lien[pt][Index(point,pt,p[1][c1])];
        else      lnk=lien[p[2][c1]][Index(point,p[2][c1],pt)];
      if(trn_color[c1]%3==1&&mark_t[c1]==0&&lnk==5)
          {
            not_mine=0;
            if(k>1)
              {
                /*** Checking the "undertriangle" ***/
                if(side==1) 
                  c2=triangle[front[k-1]][Index(point,front[k-1],pt)];
                else
                  c2=triangle[pt][Index(point,pt,front[k-1])];
                if(mark_t[c2]!=0||p[side][c1]!=p[3-side][c2])
                    not_mine=1;
                  else
                    {
                      mark_t[c2]=++(*number);
                    }
              }
            if(!not_mine)
              {
                /*** Everythig is OK, so I mark c1 ***/
                (*flag)++;
                mark_t[c1]=++(*number);
                front[k]=p[side][c1];
              }
          }
       else not_mine=1;
    }
}

/******************* Basic front description routine ************************/

void Front_Describe(trngl,tree,dom,color,trn_color,mark_t,lien,number)
  triangulation *trngl;
  tree_structure *tree;
  Domain *dom;
  int *color,*trn_color,*mark_t,**lien;
  int *number;
{
  int *nb_mat=trngl->nb_mat;
  int **point=trngl->point, **triangle=trngl->triangle;
  int (*p)[Max_trn]=trngl->p;

  int total=tree->total, *pile_value=tree->value, *pile_mode=tree->mode;
  int *pile_ref=tree->ref;

  int i,j,k,l,c,c1,l1,l2,p1,p2;
  int chef1,last_chef1,new_chef1,size, last_size;
  int front1[Max_pile],front2[Max_pile];
  int *fg1, *fg2;


  /*********** initializing chef1, last_chef1, front?, fg?, size *************/

  dom->begin=*number+1;
  size=dom->size_a;
  for(i=1;i<=size;i++) { 
                         front1[i]=dom->front2_a[i];
                         front2[i]=dom->front1_a[i];
                       }
  while(front1[size]==front2[size]&&front1[size-1]==front2[size-1]&&size>1)
    size--;
  fg1=dom->front1_b;
  fg2=dom->front2_b;
  chef1=dom->chef_a;
  new_chef1=dom->newchef_a;
  last_chef1=dom->chef_b;
  if(last_chef1==chef1)
    {
      c=new_chef1;
      new_chef1=chef1;
      chef1=c;
      size=dom->size_a;
    }

  /********************** startup for "cold" interfaces **********************/

  if(dom->node_a==-1)
    {
      /******************** Starting with a real vertex **********************/
      if(pile_mode[chef1]==2)
        {
          c1=0;
          pile_mode[total]=1;
          c=pile_value[chef1];
          pile_value[total]=p[0][c];

          /*** Is the triangle connected to another ? ***/

          for(j=0;j<3;j++)
            {
              k=p[(j+2)%3][c];
              for(l=0;point[k][l]!=p[j][c];l++);
              k=triangle[k][(l-1+nb_mat[k])%nb_mat[k]];
              for(i=0;i<total&&(pile_mode[i]!=2||pile_value[i]!=k);i++);
              if(i<total&&color[p[j][c]]==color[p[(j+2)%3][c]])
                {
                  c1++;
                  pile_value[total]=p[(j+1)%3][c];
                }
            }

          /*** If not, find the vertex in question and avoid choosing it ***/

          if(c1==0) for(j=0;j<3;j++)
            {
              k=p[j][c];
              for(i=0;i<total&&(pile_mode[i]!=1||pile_value[i]!=k);i++);
              if(i==total) pile_value[total]=p[j][c];
            }
          pile_ref[total]=chef1;
          new_chef1=chef1;
          chef1=total;
        }

      /*********************** Draw an initial front *************************/

      c=pile_value[chef1];
      size=color[c];
      front1[size]=c;
      front2[size]=c;
      for(c=size;c>1;c--)
        {
          k=front1[c];
          if(k!=fg1[c]&&k!=fg2[c])
            {
              for(l=0;l<nb_mat[k]&&color[point[k][l]]!=c-1;l++);
              if(l==nb_mat[k])
                for(l=0;color[point[k][l]]!=c-1;l++);
              i=point[k][l];
            }
          else
            if(k==fg1[c])
              i=fg1[c-1];
            else
              i=fg2[c-1];
          front1[c-1]=i;
          front2[c-1]=i;
        }
    }

  /************************* Main renumbering ********************************/

  do
    {
      c=0;

      /****************** Basic step-by-step improvement ********************/

      Go_Front(trngl,front1,fg1,1,size,mark_t,lien,trn_color,number,&c);
      Go_Front(trngl,front2,fg2,2,size,mark_t,lien,trn_color,number,&c);

      /************** Head moving : going along irregularities **************/

      if(c==0&&chef1!=last_chef1)
        { 
         last_size=size;

         /**** refreshing old l1,l2,p1,p2 ... ****/

         if(last_size>1)
           {
             i=front1[last_size-1];
             l1=triangle[i][Index(point,i,front1[last_size])];
             if(l1==0) l1=triangle[i][0]; /* Cas d'un triangle sur le bord */
             p1=p[2][l1];

             j=front2[last_size];
             l2=triangle[j][Index(point,j,front2[last_size-1])];
             if(l2==0) l2=triangle[j][0]; /* Cas d'un triangle sur le bord */
             p2=p[1][l2];
           }

          /**** Finding next chef1 ****/

          for(i=0;(i<total)&&
                ((pile_ref[i]!=new_chef1&&pile_ref[new_chef1]!=i)
                 ||i==chef1||i==new_chef1);
                i++);
          if(new_chef1<total)
            {
              /*** Changes in the top of the two fronts ***/

              if(pile_mode[new_chef1]==1)
                {
                  size=color[pile_value[new_chef1]];
                  front1[size]=pile_value[new_chef1];
                  front2[size]=pile_value[new_chef1];
                }
              else if(trn_color[pile_value[new_chef1]]%3==1)
                {
                  if(pile_mode[chef1]==1)
                    {
                      if(color[pile_value[chef1]]
                         ==trn_color[pile_value[new_chef1]]/3+1)
                        {
                          size--;
                          l=pile_value[new_chef1];
                          front1[size]=p[2][l];
                          front2[size]=p[1][l];
                        }
                    }
                  else
                    {
                      l=pile_value[new_chef1];
                      front1[trn_color[l]/3]=p[1][l];
                      front2[trn_color[l]/3]=p[2][l];
                    }
                }

              /*** Place the new chef in its place ... ***/

              /*if(i!=father) owner[chef1]=-2;*/
              chef1=new_chef1;
              new_chef1=i;
              c1=pile_value[chef1];

              /*** Fill-ins related to the new element introduced ***/

              if(last_size>1)
                {
                  if(mark_t[l1]==0&&trn_color[l1]%3==2&&
                    p[1][l1]!=fg1[last_size]&&
                    ((pile_mode[chef1]==1&&c1==p1)
                    ||(pile_mode[chef1]==2&&
                    (p[0][c1]==p1||p[1][c1]==p1||p[2][c1]==p1))))
                    {
                      mark_t[l1]=++(*number);
                      front1[size]=p1;
                      c++;
                    }
                  if(mark_t[l2]==0&&trn_color[l2]%3==2&&
                    p[2][l2]!=fg2[last_size]&&
                    ((pile_mode[chef1]==1&&c1==p2)
                    ||(pile_mode[chef1]==2&&
                    (p[0][c1]==p2||p[1][c1]==p2||p[2][c1]==p2))))
                    {
                      mark_t[l2]=++(*number);
                      front2[size]=p2;
                      c++;
                    }
                }

              /*** Mark also the new chef if it is a triangle ... ***/

              if(pile_mode[chef1]==2&&mark_t[pile_value[chef1]]==0
                 &&chef1!=last_chef1)
                {
                  mark_t[c1]=++(*number);
                }
          }
       }
    }
  while(chef1!=last_chef1||c>0);


  c=0;
  for(i=1;i<=dom->size_b;i++)
    c=c||dom->front2_b[i]!=front2[i]||dom->front1_b[i]!=front1[i];
  if(c)
    {
                  printf("\nfront1 :");
                  for(i=1;i<=size;i++) 
                    printf(" %i(%i)",front1[i],color[front1[i]]);
                  printf("\nfront2 :");
                  for(i=1;i<=size;i++) 
                    printf(" %i(%i)",front2[i],color[front2[i]]);
                  printf("\nfront1g :");
                  for(i=1;i<=dom->size_b;i++) 
                    printf(" %i",dom->front1_b[i]);
                  printf("\nfront2g :");
                  for(i=1;i<=dom->size_b;i++) 
                    printf(" %i",dom->front2_b[i]);
                  printf("\n");
    }

  dom->end=*number;
}


void Domain_reorderer(trngl,tree,dom,total,color,trn_color,mark_t,lien,
                      extract_node)
  triangulation *trngl;
  tree_structure *tree;
  Domain *dom;
  int total,*color,*trn_color,*mark_t,**lien, *extract_node;
{
  int i,j,k,number,number2;
  int chef1,chef2;
  FILE *f;
  int mark_t2[Max_trn];

  number=0;
  for(i=trngl->TRN;i>0;i--) { mark_t[i]=0; mark_t2[i]=0; }
  for(i=0;i<total;i++)
    {
      chef2=dom[i].chef_a;
      k=dom[i].newchef_a;
      do
                 {
                   chef1=chef2;
                   chef2=k;
                   for(k=0;((tree->ref[k]!=chef2&&tree->ref[chef2]!=k)
                     ||k==chef1||k==chef2)&&k<tree->total;k++);
                 } 
      while(k!=dom[i].chef_b&&k!=tree->total);
      dom[i].begin=number+1;
      number2=number;
      if(tree->mode[dom[i].node_a]==2&&mark_t2[tree->value[dom[i].node_a]]==0)
          mark_t2[tree->value[dom[i].node_a]]=++number;
      Front_Describe(trngl,tree,dom+i,color,trn_color,mark_t,lien,&number);
      if(tree->mode[dom[i].node_b]==2&&mark_t2[tree->value[dom[i].node_b]]==0)
          mark_t2[tree->value[dom[i].node_b]]=++number;
      dom[i].end=number;
    }
  printf("TRIANGLES NUMBERED : %i\n", number);

      for(j=trngl->TRN;j>0;j--)
        if(mark_t[j]==0)
          {
            mark_t[j]=mark_t2[j];
          }
  
  f=fopen(DMNS_NAME,"w");
  fwrite(&total,sizeof(int),1,f);
  j=-1;
  for(i=0;i<total;i++)
    {
      fwrite(&(dom[i].begin),sizeof(int),1,f);
      fwrite(&(dom[i].end),sizeof(int),1,f);
      if(dom[i].node_a==dom[i].node_b||dom[i].node_a==-1)
            fwrite(&j,sizeof(int),1,f);
       else fwrite(&(extract_node[dom[i].node_a]),sizeof(int),1,f);
      if(dom[i].node_b==-1)
            fwrite(&j,sizeof(int),1,f);
       else fwrite(&(extract_node[dom[i].node_b]),sizeof(int),1,f);
    }
  fclose(f);

  f=fopen(RRDR_NAME,"w");
  fwrite(&(trngl->TRN),sizeof(int),1,f);
  fwrite(mark_t,sizeof(int),trngl->TRN+1,f);
  fclose(f);
}



