/*****************************************************************************/
/*                                                                           */
/*                        Building the main tree                             */
/*                                                                           */
/*****************************************************************************/

#include "div.h"

extern int Index(int **tab,int i,int j);

void Tree_Builder(triangulation trngl,tree_structure *tree,int *mark_p,
                  int **lien,int *color,int *trn_color,int nocolor,
                  int *voisins,int *link,int *connect)
{
  int PTS=trngl.PTS, TRN=trngl.TRN, *nb_mat=trngl.nb_mat;
  int **point=trngl.point, **triangle=trngl.triangle; 
  int (*p)[Max_trn]=trngl.p;

  int i,j,k,l,c;
  int mark_t[Max_trn];
  int step_order,last_total,totalbis,mode;
  int pointe[Max_trn][3];

  for(i=0;i<=PTS;i++) mark_p[i]=0;
  for(i=0;i<=TRN;i++) { mark_t[i]=0; pointe[i][0]=0; 
			pointe[i][1]=0; pointe[i][2]=0; }  

  /************************ Drawing internal triangles ***********************/

  for(i=1;i<=TRN;i++) if(trn_color[i]%3==0) mark_t[i]=1;

  /********************* Drawing weak connexity links ************************/

  for(i=1;i<=PTS;i++) for(j=0;j<nb_mat[i];j++) if(lien[i][j]==4) mark_p[i]=1;

  /********************** Drawing ascending triangles ************************/

  for(i=1;i<=PTS;i++)
    for(j=0;j<nb_mat[i];j++)
      if(lien[i][j]==3)
	{
	    l=triangle[i][(j-1+nb_mat[i])%nb_mat[i]];
	    if(trn_color[l]%3==1)
	      {
                k=p[0][l];
		mark_t[l]=1;
		mark_p[k]=1;
		lien[k][Index(point,k,p[1][l])]=12;
		lien[k][Index(point,k,p[2][l])]=12;
		pointe[l][0]=k;
		mark_p[k]=1;
	       }
	}

  /******************** Strong connexity crossing ... ************************/

  for(i=1;i<=PTS;i++) if(voisins[i]>1) mark_p[i]=1;

  /**************************** Completing the tree **************************/

  step_order=0;
  for(l=1;l<=nocolor;l++)
    {
      step_order++;
      for(i=1;i<=PTS;i++)
	if(mark_p[i]==step_order)
	  {
	    j=0;
	    if(color[point[i][nb_mat[i]-1]]>=color[i])
	      while(color[point[i][j]]>=color[i])
		j++;
	    do {
		 while(j<nb_mat[i]&&color[point[i][j]]<color[i])
		   j++;
		 if(j<nb_mat[i]&&connect[point[i][j]]==connect[i])
		   {
		     k=triangle[i][j%nb_mat[i]];
		      if(trn_color[k]%3==0) 
		       {
			 if(pointe[k][0]<i)
			   {
			     pointe[k][2]=pointe[k][1];
			     pointe[k][1]=pointe[k][0];
			     pointe[k][0]=i;           
			   }
			  else if(pointe[k][1]<i&&pointe[k][0]!=i)
			   {               
			     pointe[k][2]=pointe[k][1];
			     pointe[k][1]=i;
			   }
			  else if(pointe[k][2]<i&&pointe[k][1]!=i)
			   {               
			     pointe[k][2]=i;
			   }
		       }
		     else    
		       {
			 k=point[i][(j+1)%nb_mat[i]];
			 if(mark_p[k]==0) mark_p[k]=step_order+1;
			 for(c=0;point[k][c]!=i;c++);
			 lien[k][c]=11;
			 lien[i][(j+1)%nb_mat[i]]=10;
		       }                         

		   }
		 while(j<nb_mat[i]&&color[point[i][j]]>=color[i]) j++;
	       }
	    while(j<nb_mat[i]);
	  }
    }
  for(i=1;i<=PTS;i++) mark_p[i]=!!mark_p[i];
 
  /********************** Building the machine's tree ************************/

  c=0;
  for(i=1;i<=TRN;i++) 
    if(mark_t[i]&&trn_color[i]==3*nocolor)
	c=i;
  if(c!=0) {
	     mode=2;
	     mark_t[c]=2;
	   }
    else   for(i=1;i<=PTS;i++)
	     if(mark_p[i]&&color[i]==nocolor)
		{ c=i; mode=1; }

  if(c>0)
    {
      if(mode==1) mark_p[c]=2;
      tree->total=1;
      totalbis=0;
      tree->value[0]=c;
      tree->mode[0]=mode;
      tree->ref[0]=0;
      while(tree->total>totalbis)
	{
	  last_total=totalbis;
	  totalbis=tree->total;
	  for(i=last_total;i<totalbis;i++)
	    {
	      c=tree->value[i];
	      mode=tree->mode[i];
	      if(mode==1)
		{
		  /**** Linking vertex to one given vertex ... ***/
		  for(j=0;j<nb_mat[c];j++)
		    if(mark_p[point[c][j]]==1)
		      {
			k=point[c][j];
			for(l=0;point[k][l]!=c;l++);
			if(lien[k][l]==11||lien[k][l]==4||
			   lien[c][j]==11||lien[c][j]==4)
			  {
			    tree->value[tree->total]=point[c][j];
			    tree->mode[tree->total]=1;
			    tree->ref[tree->total++]=i;
			    mark_p[point[c][j]]=2;
			  }
		      }
		  /**** Linking triangles to one given vertex ... ***/
		  for(j=0;j<nb_mat[c];j++)
		    {
		      k=triangle[c][j];
		      if((pointe[k][0]==c||pointe[k][1]==c||pointe[k][2]==c)
			 &&mark_t[k]==1)
			{
			  tree->value[tree->total]=triangle[c][j];
			  tree->mode[tree->total]=2;
			  tree->ref[tree->total++]=i;
			  mark_t[triangle[c][j]]=2;
			}
		    }
		}
	      else
		{
		  /**** Linking vertex to one given triangle ... ***/
		  for(j=0;j<3;j++)
		    if((pointe[c][0]==p[j][c]||pointe[c][1]==p[j][c]
		       ||pointe[c][2]==p[j][c])&&mark_p[p[j][c]]==1)

			{
			  tree->value[tree->total]=p[j][c];
			  tree->mode[tree->total]=1;
			  tree->ref[tree->total++]=i;
			  mark_p[p[j][c]]=2;
			}
		  /**** Linking triangles to one given triangle ... ***/
		   for(j=0;j<3;j++)
		    {
		      k=p[(j+2)%3][c];
		      for(l=0;point[k][l]!=p[j][c];l++);
		      k=triangle[k][(l-1+nb_mat[k])%nb_mat[k]];
		      if(mark_t[k]==1&&color[p[j][c]]==color[p[(j+2)%3][c]])
			{
			  tree->value[tree->total]=k;
			  tree->mode[tree->total]=2;
			  tree->ref[tree->total++]=i;
			  mark_t[k]=2;
			}
		    }
		}
	    }
	}
    }


  printf("Size of the spine : %i\n",tree->total);

  /**** restoring lien ****/

  for(i=1;i<=PTS;i++)
    for(j=0;j<nb_mat[i];j++)
      if(lien[i][j]==12)
	lien[i][j]=11;

}
