static	char sccsid[] = "@(#)diff.c 4.6 4/3/86";

#include <unistd.h>
#include "diff.h"
/*
 * diff - driver and subroutines
 */

#define DIFF "/bin/diff"
#define DIFFH "/usr/lib/diffh"
#define PR "/bin/pr"

char	diff[] = DIFF;
char	diffh[] = DIFFH;
char	pr[] = PR;

extern void diffdir(char **argv);
extern void diffreg(void);

void noroom(void);

void main(int argc,char **argv)
{
	register char *argp;

	ifdef1 = "FILE1"; ifdef2 = "FILE2";
	status = 2;
	diffargv = argv;
	argc--, argv++;
	while (argc > 2 && argv[0][0] == '-') {
		argp = &argv[0][1];
		argv++, argc--;
		while (*argp) switch(*argp++) {

#ifdef notdef
		case 'I':
			opt = D_IFDEF;
			wantelses = 0;
			continue;
		case 'E':
			opt = D_IFDEF;
			wantelses = 1;
			continue;
		case '1':
			opt = D_IFDEF;
			ifdef1 = argp;
			*--argp = 0;
			continue;
#endif
		case 'D':
			/* -Dfoo = -E -1 -2foo */
			wantelses = 1;
			ifdef1 = "";
			/* fall through */
#ifdef notdef
		case '2':
#endif
			opt = D_IFDEF;
			ifdef2 = argp;
			*--argp = 0;
			continue;
		case 'e':
			opt = D_EDIT;
			continue;
		case 'f':
			opt = D_REVERSE;
			continue;
		case 'n':
			opt = D_NREVERSE;
			continue;
		case 'b':
			bflag = 1;
			continue;
		case 'w':
			wflag = 1;
			continue;
		case 'i':
			iflag = 1;
			continue;
		case 't':
			tflag = 1;
			continue;
		case 'c':
			opt = D_CONTEXT;
			if (isdigit(*argp)) {
				context = atoi(argp);
				while (isdigit(*argp))
					argp++;
				if (*argp) {
					fprintf(stderr,
					    "diff: -c: bad count\n");
					done();
				}
				argp = "";
			} else
				context = 3;
			continue;
		case 'h':
			hflag++;
			continue;
		case 'S':
			if (*argp == 0) {
				fprintf(stderr, "diff: use -Sstart\n");
				done();
			}
			start = argp;
			*--argp = 0;		/* don't pass it on */
			continue;
		case 'r':
			rflag++;
			continue;
		case 's':
			sflag++;
			continue;
		case 'l':
			lflag++;
			continue;
		default:
			fprintf(stderr, "diff: -%s: unknown option\n",
			    --argp);
			done();
		}
	}
	if (argc != 2) {
		fprintf(stderr, "diff: two filename arguments required\n");
		done();
	}
	file1 = argv[0];
	file2 = argv[1];
	if (hflag && opt) {
		fprintf(stderr,
		    "diff: -h doesn't support -e, -f, -n, -c, or -I\n");
		done();
	}
	if (!strcmp(file1, "-"))
		stb1.st_mode = S_IFREG;
	else if (stat(file1, &stb1) < 0) {
		fprintf(stderr, "diff: ");
		perror(file1);
		done();
	}
	if (!strcmp(file2, "-"))
		stb2.st_mode = S_IFREG;
	else if (stat(file2, &stb2) < 0) {
		fprintf(stderr, "diff: ");
		perror(file2);
		done();
	}
	if ((stb1.st_mode & S_IFMT) == S_IFDIR &&
	    (stb2.st_mode & S_IFMT) == S_IFDIR) {
		diffdir(argv);
	} else
		diffreg();
	done();
}

char *savestr(register char *cp)
{
	register char *dp = malloc(strlen(cp)+1);

	if (dp == 0) {
		fprintf(stderr, "diff: ran out of memory\n");
		done();
	}
	strcpy(dp, cp);
	return (dp);
}

int min(int a,int b)
{

	return (a < b ? a : b);
}

int max(int a,int b)
{

	return (a > b ? a : b);
}

void done(void)
{
	if (tempfile)
		unlink(tempfile);
	exit(status);
}

char *talloc(int n)
{
	register char *p;

	if ((p = (char *) malloc((unsigned)n)) != NULL)
		return(p);
	noroom();
}

int *ralloc(int *p,int n)
{
	register int *q;

	if ((q = (int *) realloc((char *)p, (unsigned)n)) == NULL)
		noroom();
	return(q);
}

struct line *ralloc1(struct line *p,int n)
{
	register struct line *q;

	if ((q = (struct line *) realloc((char *)p, (unsigned)n)) == NULL)
		noroom();
	return(q);
}

struct cand *ralloc2(struct cand *p,int n)
{
	register struct cand *q;

	if ((q = (struct cand *) realloc((char *)p, (unsigned)n)) == NULL)
		noroom();
	return(q);
}

void noroom(void)
{
	fprintf(stderr, "diff: files too big, try -h\n");
	done();
}
