#ifndef lint
static char sccsid[] = "@(#)lmain.c	4.3 (Berkeley) 2/21/85";
#endif

# include <stdlib.h>
# include "ldefs.h"
# include "once.h"

	/* lex [-[drcyvntf]] [file] ... [file] */

	/* Copyright 1976, Bell Telephone Laboratories, Inc.,
	    written by Eric Schmidt, August 27, 1976   */

extern void warning(int s,int p,int d);
extern void error(int s,int p,int d);
extern void gch(void);
extern void scopy(char *s,char *t);
extern int slength(char *s);
extern int yyparse(void);
extern void ptail(void);
extern void mkmatch(void);
extern void cfoll(int v);
extern void cgoto(void);
extern void layout(void);
extern void statistics(void);

void mycfree(char *s,int i,int j);
void get1core(void);
void free1core(void);
void get2core(void);
void free2core(void);
void get3core(void);

void main(int argc,char **argv)
{
	register int i;
# ifdef DEBUG
#include <signal.h>
	signal(SIGBUS,buserr);
	signal(SIGSEGV,segviol);
# endif
	while (argc > 1 && argv[1][0] == '-' ){
		i = 0;
		while(argv[1][++i]){
			switch (argv[1][i]){
# ifdef DEBUG
				case 'd': debug++; break;
				case 'y': yydebug = TRUE; break;
# endif
				case 'r': case 'R':
					ratfor=TRUE; break;
				case 'c': case 'C':
					ratfor=FALSE; break;
				case 't': case 'T':
					fout = stdout;
					errorf = stderr;
					break;
				case 'v': case 'V':
					report = 1;
					break;
				case 'f': case 'F':
					optim = FALSE;
					break;
				case 'n': case 'N':
					report = 0;
					break;
				default:
					warning((int) "Unknown option %c",argv[1][i]
						,0);
				}
			}
		argc--;
		argv++;
		}
	sargc = argc;
	sargv = argv;
	if (argc > 1){
		fin = fopen(argv[++fptr], "r");		/* open argv[1] */
		sargc--;
		}
	else fin = stdin;
	if(fin == NULL)
		error ((int) "Can't read input file %s",(int) (argc>1?argv[1]:"standard input"),0);
	gch();
		/* may be gotten: def, subs, sname, schar, ccl, dchar */
	get1core();
		/* may be gotten: name, left, right, nullstr, parent */
	scopy("INITIAL",sp);
	sname[0] = sp;
	sp += slength("INITIAL") + 1;
	sname[1] = 0;
	if(yyparse()) exit(1);	/* error return code */
		/* may be disposed of: def, subs, dchar */
	free1core();
		/* may be gotten: tmpstat, foll, positions, gotof, nexts, nchar, state, atable, sfall, cpackflg */
	get2core();
	ptail();
	mkmatch();
# ifdef DEBUG
	if(debug) pccl();
# endif
	sect  = ENDSECTION;
	if(tptr>0)cfoll(tptr-1);
# ifdef DEBUG
	if(debug)pfoll();
# endif
	cgoto();
# ifdef DEBUG
	if(debug){
		printf("Print %d states:\n",stnum+1);
		for(i=0;i<=stnum;i++)stprt(i);
		}
# endif
		/* may be disposed of: positions, tmpstat, foll, state, name, left, right, parent, ccl, schar, sname */
		/* may be gotten: verify, advance, stoff */
	free2core();
	get3core();
	layout();
		/* may be disposed of: verify, advance, stoff, nexts, nchar,
			gotof, atable, ccpackflg, sfall */
# ifdef DEBUG
	free3core();
# endif
	if (ZCH>NCH) cname="/usr/lib/lex/ebcform";
	fother = fopen(ratfor?ratname:cname,"r");
	if(fother == NULL)
		if (ratfor)
			error((int) "Lex driver missing, file %s",(int) ratname,0);
		else
			error((int) "Lex driver missing, file %s",(int) cname,0);
	while ( (i=getc(fother)) != EOF)
		putc(i,fout);

	fclose(fother);
	fclose(fout);
	if(
# ifdef DEBUG
		debug   ||
# endif
			report == 1)statistics();
	fclose(stdout);
	fclose(stderr);
	exit(0);	/* success return code */
	}

void get1core(void)
{

ccptr =	ccl = myalloc(CCLSIZE,sizeof(*ccl));
pcptr = pchar = myalloc(pchlen, sizeof(*pchar));
	def = (char **) myalloc(DEFSIZE,sizeof(*def));
	subs = (char **) myalloc(DEFSIZE,sizeof(*subs));
dp =	dchar = myalloc(DEFCHAR,sizeof(*dchar));
	sname = (char **) myalloc(STARTSIZE,sizeof(*sname));
sp = 	schar = myalloc(STARTCHAR,sizeof(*schar));
	if(ccl == 0 || def == 0 || subs == 0 || dchar == 0 || sname == 0 || schar == 0)
		error((int) "Too little core to begin",0,0);
	}

void free1core(void)
{
	mycfree((char *) def,DEFSIZE,sizeof(*def));
	mycfree((char *) subs,DEFSIZE,sizeof(*subs));
	mycfree((char *) dchar,DEFCHAR,sizeof(*dchar));
	}

void get2core(void)
{
	register int i;
	gotof = (int *) myalloc(nstates,sizeof(*gotof));
	nexts = (int *) myalloc(ntrans,sizeof(*nexts));
	nchar = myalloc(ntrans,sizeof(*nchar));
	state = (int **) myalloc(nstates,sizeof(*state));
	atable = (int *) myalloc(nstates,sizeof(*atable));
	sfall = (int *) myalloc(nstates,sizeof(*sfall));
	cpackflg = myalloc(nstates,sizeof(*cpackflg));
	tmpstat = myalloc(tptr+1,sizeof(*tmpstat));
	foll = (int **) myalloc(tptr+1,sizeof(*foll));
nxtpos = positions = (int *) myalloc(maxpos,sizeof(*positions));
	if(tmpstat == 0 || foll == 0 || positions == 0 ||
		gotof == 0 || nexts == 0 || nchar == 0 || state == 0 || atable == 0 || sfall == 0 || cpackflg == 0 )
		error((int) "Too little core for state generation",0,0);
	for(i=0;i<=tptr;i++)foll[i] = 0;
	}

void free2core(void)
{
	mycfree((char *) positions,maxpos,sizeof(*positions));
	mycfree((char *) tmpstat,tptr+1,sizeof(*tmpstat));
	mycfree((char *) foll,tptr+1,sizeof(*foll));
	mycfree((char *) name,treesize,sizeof(*name));
	mycfree((char *) left,treesize,sizeof(*left));
	mycfree((char *) right,treesize,sizeof(*right));
	mycfree((char *) parent,treesize,sizeof(*parent));
	mycfree((char *) nullstr,treesize,sizeof(*nullstr));
	mycfree((char *) state,nstates,sizeof(*state));
	mycfree((char *) sname,STARTSIZE,sizeof(*sname));
	mycfree((char *) schar,STARTCHAR,sizeof(*schar));
	mycfree((char *) ccl,CCLSIZE,sizeof(*ccl));
	}

void get3core(void)
{
	verify = (int *) myalloc(outsize,sizeof(*verify));
	advance = (int *) myalloc(outsize,sizeof(*advance));
	stoff = (int *) myalloc(stnum+2,sizeof(*stoff));
	if(verify == 0 || advance == 0 || stoff == 0)
		error((int) "Too little core for final packing",0,0);
	}
# ifdef DEBUG
void free3core(void)
{
	mycfree(advance,outsize,sizeof(*advance));
	mycfree(verify,outsize,sizeof(*verify));
	mycfree(stoff,stnum+1,sizeof(*stoff));
	mycfree(gotof,nstates,sizeof(*gotof));
	mycfree(nexts,ntrans,sizeof(*nexts));
	mycfree(nchar,ntrans,sizeof(*nchar));
	mycfree(atable,nstates,sizeof(*atable));
	mycfree(sfall,nstates,sizeof(*sfall));
	mycfree(cpackflg,nstates,sizeof(*cpackflg));
	}
# endif
char *myalloc(int a,int b)
{
	register char *i;
	i = calloc(a, b);
	if(i==0)
		warning((int) "OOPS - calloc returns a 0",0,0);
	else if(i == (char *)-1){
# ifdef DEBUG
		warning("calloc returns a -1");
# endif
		return(0);
		}
	return(i);
	}
# ifdef DEBUG
void buserr(void)
{
	fflush(errorf);
	fflush(fout);
	fflush(stdout);
	fprintf(errorf,"Bus error\n");
	if(report == 1)statistics();
	fflush(errorf);
	}
void segviol(void)
{
	fflush(errorf);
	fflush(fout);
	fflush(stdout);
	fprintf(errorf,"Segmentation violation\n");
	if(report == 1)statistics();
	fflush(errorf);
	}
# endif

void yyerror(char *s)
{
	fprintf(stderr, "\"%s\", line %d: %s\n",
		fptr > 0 ? sargv[fptr] : "<stdin>", yyline, s);
}

/* i added this, cause eric passed cfree wrong number of args - martin
*/
void mycfree(char *s,int i,int j)
{
	free (s);
	/* used to be cfree, i did not find cfree anywhere,
	so i changed it to free ,  hemant oct 29, 1987 */
}
