/* $Header: util.h,v 2.0 86/09/17 15:40:06 lwall Exp $
 *
 * $Log:	util.h,v $
 * Revision 2.0  86/09/17  15:40:06  lwall
 * Baseline for netwide release.
 * 
 */

/* and for those machine that can't handle a variable argument list */

#ifdef CANVARARG

#define say1 say
#define say2 say
#define say3 say
#define say4 say
#define ask1 ask
#define ask2 ask
#define ask3 ask
#define ask4 ask
#define fatal1 fatal
#define fatal2 fatal
#define fatal3 fatal
#define fatal4 fatal

#else /* hope they allow multi-line macro actual arguments */

#ifdef lint

#define say1(a) say(a, 0, 0, 0)
#define say2(a,b) say(a, (b)==(b), 0, 0)
#define say3(a,b,c) say(a, (b)==(b), (c)==(c), 0)
#define say4(a,b,c,d) say(a, (b)==(b), (c)==(c), (d)==(d))
#define ask1(a) ask(a, 0, 0, 0)
#define ask2(a,b) ask(a, (b)==(b), 0, 0)
#define ask3(a,b,c) ask(a, (b)==(b), (c)==(c), 0)
#define ask4(a,b,c,d) ask(a, (b)==(b), (c)==(c), (d)==(d))
#define fatal1(a) fatal(a, 0, 0, 0)
#define fatal2(a,b) fatal(a, (b)==(b), 0, 0)
#define fatal3(a,b,c) fatal(a, (b)==(b), (c)==(c), 0)
#define fatal4(a,b,c,d) fatal(a, (b)==(b), (c)==(c), (d)==(d))

#else /* lint */
    /* if this doesn't work, try defining CANVARARG above */
#define say1(a) say(a, Nulllong, Nulllong, Nulllong)
#define say2(a,b) say(a, b, Nulllong, Nulllong)
#define say3(a,b,c) say(a, b, c, Nulllong)
#define say4 say
#define ask1(a) ask(a, Nulllong, Nulllong, Nulllong)
#define ask2(a,b) ask(a, b, Nulllong, Nulllong)
#define ask3(a,b,c) ask(a, b, c, Nulllong)
#define ask4 ask
#define fatal1(a) fatal(a, Nulllong, Nulllong, Nulllong)
#define fatal2(a,b) fatal(a, b, Nulllong, Nulllong)
#define fatal3(a,b,c) fatal(a, b, c, Nulllong)
#define fatal4 fatal

#endif /* lint */

/* if neither of the above work, join all multi-line macro calls. */
#endif

EXT char serrbuf[BUFSIZ];		/* buffer for stderr */

char *fetchname(char *at,int strip_leading,int assume_exists);
int move_file(char *from,char *to);
void copy_file(char *from,char *to);
void say(char *pat,long arg1,long arg2,long arg3);
void fatal(char *pat,long arg1,long arg2,long arg3);
void ask(char *pat,long arg1,long arg2,long arg3);
char *savestr(Reg1 char *s);
void set_signals(int reset);
void ignore_signals(void);
void makedirs(Reg1 char *filename,bool striplast);
